import { PostgrestSingleResponse, PostgrestMaybeSingleResponse, PostgrestResponse, PostgrestFilterBuilder } from '@supabase/postgrest-js';

declare type FetcherType = "single" | "maybeSingle" | "multiple";
declare type PostgrestFetcherResponse<Type> = Pick<PostgrestSingleResponse<Type>, "data"> | Pick<PostgrestMaybeSingleResponse<Type>, "data"> | Pick<PostgrestResponse<Type>, "data" | "count">;
declare function createFetcher<Table extends Record<string, unknown>, Result>(mode: FetcherType): (query: PostgrestFilterBuilder<Table, Result>) => Promise<PostgrestFetcherResponse<Result>>;

declare type PostgrestPaginationFetcher<Type, Args extends any[]> = (...args: Args) => Promise<Type[] | undefined>;
declare type PostgrestPaginationKeyDecoder<Args extends any[]> = (...args: Args) => {
    limit?: number;
    offset?: number;
};
declare const createPaginationFetcher: <Table extends Record<string, unknown>, Result extends Record<string, unknown>, Args extends any[]>(query: PostgrestFilterBuilder<Table, Result> | null, decode: PostgrestPaginationKeyDecoder<Args>, pageSize: number) => PostgrestPaginationFetcher<Result, Args> | null;
declare const createPaginationHasMoreFetcher: <Table extends Record<string, unknown>, Result, Args extends any[]>(query: PostgrestFilterBuilder<Table, Result> | null, decode: PostgrestPaginationKeyDecoder<Args>, pageSize: number) => PostgrestPaginationFetcher<Result | {
    hasMore: true;
}, Args> | null;

export { FetcherType, PostgrestFetcherResponse, PostgrestPaginationFetcher, PostgrestPaginationKeyDecoder, createFetcher, createPaginationFetcher, createPaginationHasMoreFetcher };
