"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  createFetcher: () => createFetcher,
  createPaginationFetcher: () => createPaginationFetcher,
  createPaginationHasMoreFetcher: () => createPaginationHasMoreFetcher
});
module.exports = __toCommonJS(src_exports);

// src/fetcher.ts
function createFetcher(mode) {
  return async (query) => {
    if (mode === "single") {
      const { data: data2 } = await query.throwOnError().single();
      return { data: data2 };
    }
    if (mode === "maybeSingle") {
      const { data: data2 } = await query.throwOnError().maybeSingle();
      return { data: data2 };
    }
    const { data, count } = await query.throwOnError();
    return { data, count };
  };
}

// src/pagination-fetcher.ts
var createPaginationFetcher = (query, decode, pageSize) => {
  if (!query)
    return null;
  return async (...args) => {
    var _a, _b;
    const decodedKey = decode(...args);
    const limit = ((_a = decodedKey.limit) != null ? _a : pageSize) - 1;
    const offset = (_b = decodedKey.offset) != null ? _b : 0;
    const { data } = await query.range(offset, offset + limit).throwOnError();
    return data != null ? data : void 0;
  };
};
var createPaginationHasMoreFetcher = (query, decode, pageSize) => {
  if (!query)
    return null;
  return async (...args) => {
    var _a, _b;
    const decodedKey = decode(...args);
    const limit = (_a = decodedKey.limit) != null ? _a : pageSize;
    const offset = (_b = decodedKey.offset) != null ? _b : 0;
    const result = await query.range(offset, offset + limit).throwOnError();
    const data = result.data;
    if (data && data.length === pageSize + 1) {
      data[data.length - 1] = { hasMore: true };
    }
    return data != null ? data : void 0;
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createFetcher,
  createPaginationFetcher,
  createPaginationHasMoreFetcher
});
//# sourceMappingURL=index.js.map